---@diagnostic disable: redundant-parameter, undefined-doc-name
-- name: \\#4d0000\\ MX moveset v1.5
-- description: mod made by Dremy_Bowser  play as the scary guy himself!!!!!              the moveset is off by default!!!      turn it on with /M 85 and turn it off with /M 64                    Ft. Birdikek (for his reduced knockback)

local movesetactive = false
local CT = gMarioStates[0].character.type
function mario_update(m)
    -- disable fall damage
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    m.peakHeight = m.pos.y
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

local can_press_x = 0

function x_pressed(m)
    if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_STAR_DANCE_WATER or m.action == ACT_DEATH_EXIT or m.action == ACT_DEATH_EXIT_LAND or m.action == ACT_DEATH_ON_BACK or m.action == ACT_DEATH_ON_STOMACH or m.action == ACT_FALLING_DEATH_EXIT or m.action == ACT_QUICKSAND_DEATH or m.action == ACT_SPECIAL_DEATH_EXIT then return end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    if m.playerIndex ~= 0 then return end
    if m.character.type ~= CT_MARIO then return end -- WAHOOOOOOOOOOO!!!!
    if not movesetactive then return end
    if m.controller.buttonPressed & X_BUTTON ~= 0 then
        if x_press_counter > 0 then
            set_jumping_action(m, ACT_WALL_KICK_AIR, 0)
            x_press_counter = x_press_counter - 1
        end
    end
  
    if (m.action & ACT_FLAG_AIR) == 0 then
        x_press_counter = 3
    end
  end
  hook_event(HOOK_MARIO_UPDATE, x_pressed)

function y_pressed(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.controller.buttonDown & Y_BUTTON ~= 0 then
        mario_set_forward_vel(m, 85) -- Innocence doesn't get you far...
    end
end

hook_event(HOOK_MARIO_UPDATE, y_pressed)



local timer = 0

ACT_DASH = allocate_mario_action(ACT_GROUP_MOVING|ACT_FLAG_MOVING|ACT_FLAG_ATTACKING|ACT_FLAG_RIDING_SHELL)

function act_dash(m)
    perform_ground_step(m)
    update_walking_speed(m)
    local val04
    if m.actionTimer < 99999 then
        m.actionTimer = m.actionTimer + 1
        m.forwardVel = 0
        val04 = 70
    else
    
        if should_begin_sliding(m) ~= 0 then
            return set_mario_action(m, ACT_BEGIN_SLIDING, 0)
        end

        if m.input & INPUT_FIRST_PERSON ~= 0 then
            return begin_braking_action(m)
        end

        if m.input & INPUT_A_PRESSED ~= 0 then
            return set_jump_from_landing(m)
        end

        if check_ground_dive_or_punch(m) ~= 0 then
            return true
        end

        if m.input & INPUT_Z_PRESSED ~= 0 then
            return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
        end

        local ground_step = perform_ground_step(m)

        if ground_step == GROUND_STEP_LEFT_GROUND then
            set_mario_action(m, ACT_FREEFALL, 0)
            set_character_animation(m, CHAR_ANIM_GENERAL_FALL)

        elseif ground_step == GROUND_STEP_HIT_WALL then
            set_mario_action(m, ACT_BACKWARD_GROUND_KB, 0)
            --play_sound(SOUND_OBJ_BOWSER_WALK, m.marioObj.header.gfx.cameraToObject)
            set_camera_shake_from_hit(4)
        end
    end
    smlua_anim_util_set_animation(m.marioObj, "MX_ANIM_BRICK_BREAKER")
    m.marioObj.header.gfx.animInfo.animAccel = 65536 * (5)
    play_step_sound(m, 15, 35)
end


hook_mario_action(ACT_DASH, act_dash, INT_KICK)


function update(m)
    if m.character.type ~= CT_MARIO then return end 
    if not movesetactive then return end
    if m.input &  INPUT_ZERO_MOVEMENT ~= 0 and m.action == ACT_DASH then
    set_mario_action(m, ACT_IDLE, 0)
    end
end

hook_event(HOOK_MARIO_UPDATE, update)









function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_DASH and m.actionTimer > 0 and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        set_mario_action(m, ACT_JUMP, 0)
   
    end
    if m.action == ACT_DASH then
        m.actionTimer = m.actionTimer + 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_DASH and m.actionTimer > 0 and (m.controller.buttonPressed & Z_TRIG) ~= 0 then
        set_mario_action(m, ACT_LONG_JUMP, 0)
   
    end
    if m.action == ACT_DASH then
        m.actionTimer = m.actionTimer + 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
    if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_STAR_DANCE_WATER or m.action == ACT_DEATH_EXIT or m.action == ACT_DEATH_EXIT_LAND or m.action == ACT_DEATH_ON_BACK or m.action == ACT_DEATH_ON_STOMACH or m.action == ACT_FALLING_DEATH_EXIT or m.action == ACT_QUICKSAND_DEATH or m.action == ACT_SPECIAL_DEATH_EXIT then return end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.playerIndex ~= 0 then return end
    timer = timer + 1
    if m.pos.y == m.floorHeight then

    if m.controller.buttonPressed & Y_BUTTON ~= 0 and m.action ~= ACT_DASH and m.pos.y == m.floorHeight and
    (m.action & ACT_GROUP_MASK) ~= ACT_GROUP_SUBMERGED then
        set_mario_action(m, ACT_DASH, 0)
    end
end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)



--- @param msg string
--this is the function for enabling or disabling some moveset, 
 local function movesettoggle_command(msg)
    local m = string.lower(msg) --making the msg string be lowercase 
    if m == '85' then
        movesetactive = true
        djui_chat_message_create(' \\#Ff0000\\WAHHOOOO\\#ffffff\\!!!!')
        djui_popup_create(" \\#Ff0000\\You are MX", 1)
        return true
    elseif m == '64' then
        movesetactive = false
        djui_chat_message_create('\\#990000\\See you next time. . ') 
        djui_popup_create("\\#990000\\You are no longer MX", 1)
        return true

    end
    return false

end
hook_chat_command('M', "[85|64] turn moveset \\#00C7FF\\on \\#ffffff\\or \\#A02200\\off \\#ffffff\\. ", movesettoggle_command)



function mario_update(m)
    if not movesetactive then return end
    if m.character.type ~= CT_MARIO then return end
    if m.action == ACT_GROUND_POUND_LAND and (m.input & INPUT_A_PRESSED) ~= 0 then
        set_mario_action(m, ACT_TRIPLE_JUMP, 0)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)


-- Boss character BS --

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    gPlayerSyncTable[i].Walk = true
    if type == STEP_TYPE_AIR and m.vel.y < 0 then
        ray = collision_find_surface_on_ray(m.pos.x, m.pos.y, m.pos.z, m.vel.x, m.vel.y, m.vel.z)
        if ray.surface ~= nil then
            if ray.surface.normal.y ~= 0 then
                m.peakHeight = m.pos.y
            end
        end
    end
end

hook_event(HOOK_ALLOW_HAZARD_SURFACE, function(m) return not (m.character.type == CT_MARIO and movesetactive) end)

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_DOUBLE_JUMP then
        m.action = ACT_JUMP
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.forwardVel >= 60 then
        m.flags = m.flags | MARIO_METAL_CAP
    else
        m.flags = m.flags & ~MARIO_METAL_CAP
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_GROUND_POUND_LAND then
        set_camera_shake_from_hit(SHAKE_MED_DAMAGE)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

local timer = 0

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    m = gMarioStates[0]
    if m.action == ACT_BACKWARD_AIR_KB or m.action == ACT_FORWARD_AIR_KB then
        local randomtime = math.random(80, 140) -- thank you Birdikek!!!!!!!!!
        timer = timer + 1
        if timer >= randomtime then
            set_mario_action(m, ACT_IDLE, 0)
        end
    else
        timer = 0
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)


gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]
end

gEventTable     = {}

ACT_MARIO_PUNCH = (0x05B | ACT_FLAG_MOVING | ACT_FLAG_ATTACKING)    -- get back here!!!!
function act_mario_punch(m)
    if m.health == 0xFF then return end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    local e = gStateExtras[m.playerIndex]
    if m.actionTimer == 0 then
        m.actionState = m.actionArg
        play_character_sound(m,CHAR_SOUND_HAHA )
    end
    common_slide_action(m, ACT_WALKING, ACT_FLAG_ATTACKING, MARIO_ANIM_FIRST_PUNCH)
    set_anim_to_frame(m, 25)
    m.slideVelX = m.slideVelX * 1.3
    m.slideVelZ = m.slideVelZ * 1.3
    update_sliding(m, -1)
    if m.actionTimer > 20 then
        return set_mario_action(m, ACT_WALKING, 85)
    end
    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jumping_action(m, ACT_JUMP, 0)
    end
    m.actionTimer = m.actionTimer + 1
    return 0
end

function mario_update(m)
    if m.health == 0xFF then return end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    local hScale = 1.0
    if (m.controller.buttonPressed & L_JPAD) ~= 0 and (m.action & ACT_FLAG_MOVING) ~= 0 then
        m.actionTimer = 0
        return set_mario_action(m, ACT_MARIO_PUNCH, 0)
    end
    if (m.action & ACT_FLAG_AIR) ~= 0 then
        m.vel.y = m.vel.y - 0.1
    end
    if (m.action & ACT_FLAG_MOVING) ~= 0 then
        hScale = hScale * 1.4
    end
    m.vel.x = m.vel.x * hScale
    m.vel.z = m.vel.z * hScale
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_mario_action(ACT_MARIO_PUNCH, act_mario_punch, INT_KICK)


function mario_on_set_action(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_LONG_JUMP then
        m.vel.y = m.vel.y + 3
    elseif m.action == ACT_EMERGE_FROM_PIPE then
        m.vel.y = m.vel.y + 10
    end
    if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_WALL_KICK_AIR then
        m.vel.y = m.vel.y + 4
    end
end

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_DIVE or m.action == ACT_JUMP_KICK or m.action == ACT_BACKWARD_ROLLOUT or m.action == ACT_FORWARD_ROLLOUT or m.action == ACT_WATER_JUMP or m.action == ACT_WALL_KICK_AIR then
        m.vel.y = m.vel.y + 0.4
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

function mario_update_local(m)
    local p  = gNetworkPlayers[m.playerIndex]
    local np = gNetworkPlayers[m.playerIndex]
    local s  = gPlayerSyncTable[m.playerIndex]

    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_GROUND_POUND_LAND and gServerSettings.playerInteractions ~= PLAYER_INTERACTIONS_NONE then
        queue_rumble_data_mario(m, 5, 80)
        play_sound(CHAR_SOUND_MAMA_MIA, m.marioObj.header.gfx.cameraToObject)
        set_mario_action(m, ACT_GROUND_POUND_LAND, 0)
        if m.action == ACT_BUTT_STUCK_IN_GROUND then
            m.actionTimer = m.actionTimer + 1
        end

        if m.action == ACT_GROUND_POUND_LAND and m.actionTimer >= 9 then
            set_mario_action(m, ACT_BUTT_SLIDE_STOP, 0)
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update_local)




 ANGLE_QUEUE_SIZE = 9
 SPIN_TIMER_SUCCESSFUL_INPUT = 4

 gMarioStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gMarioStateExtras[i] = {}
     m = gMarioStates[i]
     e = gMarioStateExtras[i]
    e.angleDeltaQueue = {}
    for j = 0, (ANGLE_QUEUE_SIZE - 1) do e.angleDeltaQueue[j] = 0 end
    e.rotAngle = 0
    e.boostTimer = 0

    e.stickLastAngle = 0
    e.spinDirection = 0
    e.spinBufferTimer = 0
    e.spinInput = 0
    e.lastIntendedMag = 0

    e.lastPos = {}
    e.lastPos.x = m.pos.x
    e.lastPos.y = m.pos.y
    e.lastPos.z = m.pos.z

    e.fakeSavedAction = 0
    e.fakeSavedPrevAction = 0
    e.fakeSavedActionTimer = 0
    e.fakeWroteAction = 0
    e.fakeSaved = false

    e.savedWallSlideHeight = 0
    e.savedWallSlide = false
end

 function limit_angle(a)
    return (a + 0x8000) % 0x10000 - 0x8000
end


 allocate_mario_action, atan2s, sins, coss, mario_update_moving_sand, mario_update_windy_ground, mario_floor_is_slope, mario_set_forward_vel, set_mario_action, queue_rumble_data_mario, set_jumping_action, play_mario_sound, play_sound, set_mario_animation, common_slide_action, set_anim_to_frame, check_fall_damage_or_get_stuck, play_sound_and_spawn_particles, mario_bonk_reflection, play_mario_landing_sound_once, common_air_action_step, perform_air_step, should_get_stuck_in_ground, play_mario_heavy_landing_sound, check_fall_damage, set_camera_shake_from_hit, drop_and_set_mario_action, stationary_ground_step, check_common_action_exits, stopping_step, mario_drop_held_object, perform_water_step, perform_water_full_step, vec3f_copy, vec3s_set, approach_f32, is_anim_at_end, float_surface_gfx, set_swimming_at_surface_particles, apply_water_current, update_air_without_turn, play_mario_landing_sound, lava_boost_on_wall, check_kick_or_dive_in_air, update_sliding, mario_check_object_grab, mario_grab_used_object, analog_stick_held_back, approach_s32, apply_slope_accel, should_begin_sliding, begin_braking_action, set_jump_from_landing, check_ground_dive_or_punch, anim_and_audio_for_walk, perform_ground_step, push_or_sidle_wall, check_ledge_climb_down, tilt_body_walking, anim_and_audio_for_hold_walk, anim_and_audio_for_heavy_walk, align_with_floor, set_mario_anim_with_accel, play_step_sound =
    allocate_mario_action, atan2s, sins, coss, mario_update_moving_sand, mario_update_windy_ground, mario_floor_is_slope,
    mario_set_forward_vel, set_mario_action, queue_rumble_data_mario, set_jumping_action, play_mario_sound, play_sound,
    set_mario_animation, common_slide_action, set_anim_to_frame, check_fall_damage_or_get_stuck,
    play_sound_and_spawn_particles, mario_bonk_reflection, play_mario_landing_sound_once, common_air_action_step,
    perform_air_step, should_get_stuck_in_ground, play_mario_heavy_landing_sound, check_fall_damage,
    set_camera_shake_from_hit, drop_and_set_mario_action, stationary_ground_step, check_common_action_exits,
    stopping_step, mario_drop_held_object, perform_water_step, perform_water_full_step, vec3f_copy, vec3s_set,
    approach_f32, is_anim_at_end, float_surface_gfx, set_swimming_at_surface_particles, apply_water_current,
    update_air_without_turn, play_mario_landing_sound, lava_boost_on_wall, check_kick_or_dive_in_air, update_sliding,
    mario_check_object_grab, mario_grab_used_object, analog_stick_held_back, approach_s32, apply_slope_accel,
    should_begin_sliding, begin_braking_action, set_jump_from_landing, check_ground_dive_or_punch,
    anim_and_audio_for_walk, perform_ground_step, push_or_sidle_wall, check_ledge_climb_down, tilt_body_walking,
    anim_and_audio_for_hold_walk, anim_and_audio_for_heavy_walk, align_with_floor, set_mario_anim_with_accel,
    play_step_sound

 math_sqrt, math_min, math_max, math_floor = math.sqrt, math.min, math.max, math.floor


 ACT_ROLL = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE|
ACT_FLAG_ATTACKING)
function update_roll_sliding_angle(m, accel, lossFactor)

     floor = m.floor
     slopeAngle = atan2s(floor.normal.z, floor.normal.x)
     steepness = math_sqrt(floor.normal.x * floor.normal.x + floor.normal.z * floor.normal.z)

    m.slideVelX = m.slideVelX + accel * steepness * sins(slopeAngle)
    m.slideVelZ = m.slideVelZ + accel * steepness * coss(slopeAngle)

    m.slideVelX = m.slideVelX * lossFactor
    m.slideVelZ = m.slideVelZ * lossFactor

    m.slideYaw = atan2s(m.slideVelZ, m.slideVelX)

     facingDYaw = limit_angle(m.faceAngle.y - m.slideYaw)
     newFacingDYaw = facingDYaw

    if newFacingDYaw > 0 and newFacingDYaw <= 0x8000 then
        newFacingDYaw = newFacingDYaw - 0x800
        if newFacingDYaw < 0 then newFacingDYaw = 0 end
    elseif newFacingDYaw >= -0x8000 and newFacingDYaw < 0 then
        newFacingDYaw = newFacingDYaw + 0x800
        if newFacingDYaw > 0 then newFacingDYaw = 0 end
    end

    m.faceAngle.y = limit_angle(m.slideYaw + newFacingDYaw)

    m.vel.x = m.slideVelX
    m.vel.y = 0.0
    m.vel.z = m.slideVelZ

    mario_update_moving_sand(m)
    mario_update_windy_ground(m)


    m.forwardVel = math_sqrt(m.slideVelX * m.slideVelX + m.slideVelZ * m.slideVelZ)
    if m.forwardVel > 100.0 then
        m.slideVelX = m.slideVelX * 100.0 / m.forwardVel
        m.slideVelZ = m.slideVelZ * 100.0 / m.forwardVel
    end
end

 function update_roll_sliding(m, stopSpeed)
    stopped = 0

     intendedDYaw = m.intendedYaw - m.slideYaw
     forward = coss(intendedDYaw)
    sideward = sins(intendedDYaw)


    if forward < 0.0 and m.forwardVel >= 0.0 then
        forward = forward * (0.5 + 0.5 * m.forwardVel / 100.0)
    end

     accel        = 4.0
     lossFactor   = 0.994

     oldSpeed     = math_sqrt(m.slideVelX * m.slideVelX + m.slideVelZ * m.slideVelZ)
     angleChange  = (m.intendedMag / 32.0) * 0.6
     modSlideVelX = m.slideVelZ * angleChange * sideward * 0.05
     modSlideVelZ = m.slideVelX * angleChange * sideward * 0.05

    m.slideVelX        = m.slideVelX + modSlideVelX
    m.slideVelZ        = m.slideVelZ - modSlideVelZ

     newSpeed     = math_sqrt(m.slideVelX * m.slideVelX + m.slideVelZ * m.slideVelZ)

    if oldSpeed > 0.0 and newSpeed > 0.0 then
        m.slideVelX = m.slideVelX * oldSpeed / newSpeed
        m.slideVelZ = m.slideVelZ * oldSpeed / newSpeed
    end

    update_roll_sliding_angle(m, accel, lossFactor)

    if m.playerIndex == 0 and mario_floor_is_slope(m) == 0 and m.forwardVel * m.forwardVel < stopSpeed * stopSpeed then
        mario_set_forward_vel(m, 0.0)
        stopped = 1
    end

    return stopped
end

 ACT_ROLL_AIR = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION |
ACT_FLAG_ATTACKING)
 function act_roll(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    local e = gMarioStateExtras[m.playerIndex]

     MAX_NORMAL_ROLL_SPEED = 70.0
     ROLL_BOOST_GAIN = 15.0
     ROLL_CANCEL_LOCKOUT_TIME = 10
     BOOST_LOCKOUT_TIME = 20

    if m.actionTimer == 0 then
        if m.prevAction ~= ACT_ROLL_AIR then
            e.rotAngle = 0
            e.boostTimer = 0
        end
    elseif m.actionTimer >= ROLL_CANCEL_LOCKOUT_TIME or m.actionArg == 1 then
        if (m.input & INPUT_Z_DOWN) == 0 then
            return set_mario_action(m, ACT_WALKING, 0)
        end
    end

    if (m.input & INPUT_B_PRESSED) ~= 0 then
        queue_rumble_data_mario(m, 5, 80)
        return set_jumping_action(m, ACT_FORWARD_ROLLOUT, 0)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jumping_action(m, ACT_LONG_JUMP, 0)
    end

    if (m.controller.buttonPressed & L_TRIG) ~= 0 and m.actionTimer > 0 then
        m.vel.y = 19.0
        play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

        if e.boostTimer >= BOOST_LOCKOUT_TIME then
            e.boostTimer = 0

            if m.forwardVel < MAX_NORMAL_ROLL_SPEED then
                mario_set_forward_vel(m, math_min(m.forwardVel + ROLL_BOOST_GAIN, MAX_NORMAL_ROLL_SPEED))
            end

            m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)
        end

        return set_mario_action(m, ACT_ROLL_AIR, m.actionArg)
    end

    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)

    if update_roll_sliding(m, 10.0) ~= 0 then
        return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
    end

    common_slide_action(m, ACT_CROUCH_SLIDE, ACT_ROLL_AIR, MARIO_ANIM_FORWARD_SPINNING)

    e.rotAngle = e.rotAngle + (0x80 * m.forwardVel)
    if e.rotAngle > 0x10000 then
        e.rotAngle = e.rotAngle - 0x10000
    end
    set_anim_to_frame(m, 10 * e.rotAngle / 0x10000)

    e.boostTimer = e.boostTimer + 1

    m.actionTimer = m.actionTimer + 1

    return 0
end

 function act_roll_air(m)
     e = gMarioStateExtras[m.playerIndex]
     MAX_NORMAL_ROLL_SPEED = 50.0
     ROLL_AIR_CANCEL_LOCKOUT_TIME = 15

    if m.actionTimer == 0 then
        if m.prevAction ~= ACT_ROLL then
            e.rotAngle   = 0
            e.boostTimer = 0
        end
    end

    if (m.input & INPUT_Z_DOWN) == 0 and m.actionTimer >= ROLL_AIR_CANCEL_LOCKOUT_TIME then
        return set_mario_action(m, ACT_FREEFALL, 0)
    end

    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)

    air_step = perform_air_step(m, 0)
    if air_step == AIR_STEP_LANDED then
        if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
            play_sound_and_spawn_particles(m, SOUND_ACTION_TERRAIN_STEP, 0)
            return set_mario_action(m, ACT_ROLL, m.actionArg)
        end
    elseif air_step == AIR_STEP_HIT_WALL then
        queue_rumble_data_mario(m, 5, 40)
        mario_bonk_reflection(m, false)
        m.faceAngle.y = m.faceAngle.y + 0x8000

        if m.vel.y > 0.0 then
            m.vel.y = 0.0
        end

        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
        return set_mario_action(m, ACT_BACKWARD_AIR_KB, 0)
    end

    e.rotAngle = e.rotAngle + 0x80 * m.forwardVel
    if e.rotAngle > 0x10000 then
        e.rotAngle = e.rotAngle - 0x10000
    end

    set_anim_to_frame(m, 10 * e.rotAngle / 0x10000)

    e.boostTimer = e.boostTimer + 1
    m.actionTimer = m.actionTimer + 1

    return false
end

 function update_roll(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_DIVE_SLIDE then
        if (m.input & INPUT_ABOVE_SLIDE) == 0 then
            if (m.input & INPUT_Z_DOWN) ~= 0 and m.actionTimer < 2 then
                return set_mario_action(m, ACT_ROLL, 1)
            end
        end
        m.actionTimer = m.actionTimer + 1
    end

    if m.action == ACT_LONG_JUMP_LAND then
        if (m.input & INPUT_Z_DOWN) ~= 0 and m.forwardVel > 15.0 and m.actionTimer < 1 then
            play_mario_landing_sound_once(m, SOUND_ACTION_TERRAIN_LANDING)
            return set_mario_action(m, ACT_ROLL, 1)
        end
    end

    if m.action == ACT_CROUCHING then
        if (m.controller.buttonPressed & L_TRIG) ~= 0 then
            m.vel.y = 19.0
            mario_set_forward_vel(m, 32.0)
            play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)

            return set_mario_action(m, ACT_ROLL_AIR, 0)
        end
    end

    if m.action == ACT_CROUCH_SLIDE then
        if (m.controller.buttonPressed & L_TRIG) ~= 0 then
            m.vel.y = 19.0
            mario_set_forward_vel(m, math_max(32, m.forwardVel))
            play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)

            return set_mario_action(m, ACT_ROLL_AIR, 0)
        end
    end

    if m.action == ACT_GROUND_POUND_LAND then
        if (m.controller.buttonPressed & L_TRIG) ~= 0 then
            mario_set_forward_vel(m, 60)

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)

            return set_mario_action(m, ACT_ROLL, 0)
        end
    end
end
hook_mario_action(ACT_ROLL, { every_frame = act_roll }, INT_KICK)
hook_event(HOOK_MARIO_UPDATE, update_roll)
hook_mario_action(ACT_ROLL_AIR, { every_frame = act_roll_air },INT_KICK)
hook_mario_action(ACT_ROLL_AIR, update_roll_sliding)
hook_mario_action(ACT_ROLL, update_roll_sliding_angle)

function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.action == ACT_PICKING_UP_BOWSER then m.action = ACT_PICKING_UP end

if m.action == ACT_RELEASING_BOWSER then m.action = ACT_THROWING
end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)


function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.playerIndex ~= 0 then return end
    if m.hurtCounter > 1 then
        m.hurtCounter = 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
    gPlayerSyncTable[0].modelId = math.random(0, E_MODEL_MAX - 1)
    if not movesetactive then return end
if m.action == ACT_JUMP then set_mario_animation(m, CHAR_ANIM_RUNNING_UNUSED  )
end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)


ACT_BIG_STOMP =		 ( ACT_FLAG_AIR | ACT_FLAG_ATTACKING | ACT_FLAG_INVULNERABLE | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_ATTACKING )

function act_big_stomp(m)
    

    common_air_action_step(m, ACT_GROUND_POUND_LAND, CHAR_ANIM_LAND_FROM_DOUBLE_JUMP , AIR_STEP_NONE)
set_mario_animation(m,CHAR_ANIM_LAND_FROM_DOUBLE_JUMP  )

end
 hook_mario_action(ACT_BIG_STOMP,  act_big_stomp,  INT_KICK)

    function mario_update(m)
        if m.character.type ~= CT_MARIO then return end
        if not movesetactive then return end
    if m.action == ACT_TRIPLE_JUMP_LAND then set_mario_action(m, ACT_BIG_STOMP, 0)
    end
    end
    hook_event(HOOK_MARIO_UPDATE, mario_update)


    function mario_before_phys_step(m)
        if m.character.type ~= CT_MARIO then return end
        if not movesetactive then return end

    local hScale = 1.0
    
        if m.action == ACT_HOLD_WALKING then
            hScale = hScale + 4
        end
    end
  hook_event(HOOK_BEFORE_PHYS_STEP, mario_before_phys_step)


  function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    local e = gStateExtras[m.playerIndex]


    -- turn heavy objects into light
    if m.action == ACT_HOLD_HEAVY_IDLE then
        return set_mario_action(m, ACT_HOLD_IDLE, 0)
    end

    -- faster ground pound
    if m.action == ACT_GROUND_POUND then
        m.vel.y = m.vel.y * 1.8
    end


end
hook_event(HOOK_MARIO_UPDATE, mario_update)


function mario_update(m)
    if m.character.type ~= CT_MARIO then return end

    local e = gStateExtras[m.playerIndex]
    if m.action == ACT_DASH then play_character_sound(m,CHAR_SOUND_HAHA )
    end
end
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_update)




smlua_anim_util_register_animation("MX_ANIM_BRICK_BREAKER",
    0,
    0,
    0,
    0,
    40,
    {
    0x0000, 0x00D9, 0x00D4, 0x00CF, 0x00CA, 0x00C5, 0x00C0, 0x00C3, 0x00C6, 
    0x00C9, 0x00CB, 0x00CE, 0x00CE, 0x00CE, 0x00CE, 0x00CE, 0x00CE, 0x00D0, 
    0x00D2, 0x00D4, 0x00D7, 0x00D9, 0x00D4, 0x00CF, 0x00CA, 0x00C5, 0x00C0, 
    0x00C3, 0x00C6, 0x00C9, 0x00CB, 0x00CE, 0x00CE, 0x00CE, 0x00CE, 0x00CE, 
    0x00CE, 0x00D0, 0x00D2, 0x00D4, 0x00D7, 0x00D9, 0x0000, 0xFFFF, 0x3FFF, 
    0xFFFF, 0xF633, 0xFAB3, 0xFF33, 0x03B3, 0x0833, 0x0CB3, 0x100A, 0x1361, 
    0x16B8, 0x1A0F, 0x1D66, 0x1B32, 0x18FE, 0x16CA, 0x1496, 0x1262, 0x1120, 
    0x0FDE, 0x0E9D, 0x0D5B, 0x0C19, 0x05A9, 0xFF38, 0xF8C8, 0xF257, 0xEBE7, 
    0xEA2B, 0xE86F, 0xE6B3, 0xE4F7, 0xE33A, 0xE535, 0xE730, 0xE92B, 0xEB26, 
    0xED21, 0xEEF1, 0xF0C2, 0xF292, 0xF463, 0xF633, 0xF856, 0xF872, 0xF88E, 
    0xF8AA, 0xF8C6, 0xF8E2, 0xF9A0, 0xFA5E, 0xFB1C, 0xFBD9, 0xFC97, 0xFC89, 
    0xFC7A, 0xFC6B, 0xFC5D, 0xFC4E, 0xFE57, 0x0060, 0x0268, 0x0470, 0x0678, 
    0x08A6, 0x0AD4, 0x0D01, 0x0F2F, 0x115C, 0x115E, 0x115F, 0x1160, 0x1161, 
    0x1162, 0x0F94, 0x0DC5, 0x0BF7, 0x0A29, 0x085A, 0x0527, 0x01F3, 0xFEBE, 
    0xFB8A, 0xF856, 0x4E2F, 0x4DC1, 0x4D54, 0x4CE6, 0x4C78, 0x4C0B, 0x4D36, 
    0x4E62, 0x4F8D, 0x50B9, 0x51E4, 0x5235, 0x5286, 0x52D7, 0x5328, 0x5379, 
    0x532F, 0x52E6, 0x529D, 0x5254, 0x520B, 0x5013, 0x4E1B, 0x4C24, 0x4A2C, 
    0x4834, 0x4AD4, 0x4D73, 0x5013, 0x52B2, 0x5551, 0x53F2, 0x5292, 0x5132, 
    0x4FD2, 0x4E72, 0x4E65, 0x4E58, 0x4E4A, 0x4E3D, 0x4E2F, 0xE20E, 0xDCE9, 
    0xD7C4, 0xD2A0, 0xCD7B, 0xC856, 0xC493, 0xC0CF, 0xBD0B, 0xB948, 0xB584, 
    0xB917, 0xBCA9, 0xC03C, 0xC3CE, 0xC761, 0xC739, 0xC711, 0xC6E8, 0xC6C0, 
    0xC698, 0xCAF2, 0xCF4C, 0xD3A6, 0xD801, 0xDC5B, 0xDF1F, 0xE1E4, 0xE4A9, 
    0xE76E, 0xEA32, 0xE8F6, 0xE7BA, 0xE67E, 0xE542, 0xE406, 0xE3A1, 0xE33C, 
    0xE2D7, 0xE273, 0xE20E, 0x0FF0, 0x115F, 0x12CF, 0x143E, 0x15AE, 0x171E, 
    0x17A7, 0x1831, 0x18BB, 0x1944, 0x19CE, 0x1989, 0x1945, 0x1901, 0x18BD, 
    0x1878, 0x1603, 0x138D, 0x1118, 0x0EA2, 0x0C2D, 0x079D, 0x030E, 0xFE7D, 
    0xF9EE, 0xF55F, 0xF553, 0xF547, 0xF53B, 0xF52F, 0xF524, 0xF6A9, 0xF82F, 
    0xF9B4, 0xFB3A, 0xFCBF, 0x0096, 0x046D, 0x0843, 0x0C19, 0x0FF0, 0x18D2, 
    0x1643, 0x13B5, 0x1126, 0x0E98, 0x0C09, 0x0A16, 0x0823, 0x0630, 0x043D, 
    0x024A, 0x03F1, 0x0598, 0x073F, 0x08E6, 0x0A8D, 0x0AC0, 0x0AF4, 0x0B27, 
    0x0B5B, 0x0B8F, 0x0D70, 0x0F52, 0x1133, 0x1315, 0x14F7, 0x12D1, 0x10AB, 
    0x0E85, 0x0C5F, 0x0A39, 0x0D07, 0x0FD5, 0x12A3, 0x1571, 0x183F, 0x185C, 
    0x187A, 0x1897, 0x18B4, 0x18D2, 0x1107, 0x1148, 0x1189, 0x11CA, 0x120B, 
    0x124C, 0x128D, 0x12CE, 0x1310, 0x1351, 0x1392, 0x1351, 0x1310, 0x12CE, 
    0x128D, 0x124C, 0x120B, 0x11CA, 0x1189, 0x1148, 0x1107, 0x1107, 0x1107, 
    0x1107, 0x1107, 0x1107, 0x1189, 0x120B, 0x128D, 0x1310, 0x1392, 0x1351, 
    0x1310, 0x12CE, 0x128D, 0x124C, 0x120B, 0x11CA, 0x1189, 0x1148, 0x1107, 
    0x1743, 0x16BE, 0x1639, 0x15B4, 0x1530, 0x14AB, 0x1426, 0x13A2, 0x131D, 
    0x1298, 0x1213, 0x1298, 0x131D, 0x13A2, 0x1426, 0x14AB, 0x1530, 0x15B4, 
    0x1639, 0x16BE, 0x1743, 0x1743, 0x1743, 0x1743, 0x1743, 0x1743, 0x1639, 
    0x1530, 0x1426, 0x131D, 0x1213, 0x1298, 0x131D, 0x13A2, 0x1426, 0x14AB, 
    0x1530, 0x15B4, 0x1639, 0x16BE, 0x1743, 0xF8AB, 0xF972, 0xFA39, 0xFAFF, 
    0xFBC6, 0xFC8D, 0xFD54, 0xFE1A, 0xFEE1, 0xFFA8, 0x0070, 0xFFA8, 0xFEE1, 
    0xFE1A, 0xFD54, 0xFC8D, 0xFBC6, 0xFAFF, 0xFA39, 0xF972, 0xF8AB, 0xF8AB, 
    0xF8AB, 0xF8AB, 0xF8AB, 0xF8AB, 0xFA39, 0xFBC6, 0xFD54, 0xFEE1, 0x0070, 
    0xFFA8, 0xFEE1, 0xFE1A, 0xFD54, 0xFC8D, 0xFBC6, 0xFAFF, 0xFA39, 0xF972, 
    0xF8AB, 0xFFFE, 0x0001, 0xC170, 0xC6AC, 0xC682, 0xC657, 0xC62D, 0xC603, 
    0xC5D8, 0xC5AE, 0xC584, 0xC559, 0xC52F, 0xC504, 0xC52F, 0xC559, 0xC584, 
    0xC5AE, 0xC5D8, 0xC603, 0xC62D, 0xC657, 0xC682, 0xC6AC, 0xC6AC, 0xC6AC, 
    0xC6AC, 0xC6AC, 0xC6AC, 0xC657, 0xC603, 0xC5AE, 0xC559, 0xC504, 0xC52F, 
    0xC559, 0xC584, 0xC5AE, 0xC5D8, 0xC603, 0xC62D, 0xC657, 0xC682, 0xC6AC, 
    0x89B7, 0x899A, 0x897E, 0x8962, 0x8945, 0x8929, 0x890C, 0x88F0, 0x88D3, 
    0x88B7, 0x889A, 0x88B7, 0x88D3, 0x88F0, 0x890C, 0x8929, 0x8945, 0x8962, 
    0x897E, 0x899A, 0x89B7, 0x89B7, 0x89B7, 0x89B7, 0x89B7, 0x89B7, 0x897E, 
    0x8945, 0x890C, 0x88D3, 0x889A, 0x88B7, 0x88D3, 0x88F0, 0x890C, 0x8929, 
    0x8945, 0x8962, 0x897E, 0x899A, 0x89B7, 0x00C3, 0x00CA, 0x00D1, 0x00D8, 
    0x00DF, 0x00E6, 0x00EC, 0x00F3, 0x00FA, 0x0101, 0x0108, 0x0101, 0x00FA, 
    0x00F3, 0x00EC, 0x00E6, 0x00DF, 0x00D8, 0x00D1, 0x00CA, 0x00C3, 0x00C3, 
    0x00C3, 0x00C3, 0x00C3, 0x00C3, 0x00D1, 0x00DF, 0x00EC, 0x00FA, 0x0108, 
    0x0101, 0x00FA, 0x00F3, 0x00EC, 0x00E6, 0x00DF, 0x00D8, 0x00D1, 0x00CA, 
    0x00C3, 0x0938, 0xFB79, 0xCE23, 0xFF89, 0xF97F, 0xF06E, 0xFFFE, 0x0001, 
    0xC170, 0x2875, 0x2810, 0x27AB, 0x2746, 0x26E1, 0x267C, 0x2617, 0x25B2, 
    0x254D, 0x24E8, 0x2483, 0x25E0, 0x273D, 0x289A, 0x29F7, 0x2B54, 0x2AC1, 
    0x2A2E, 0x299B, 0x2908, 0x2875, 0x2810, 0x27AB, 0x2746, 0x26E1, 0x267C, 
    0x2617, 0x25B2, 0x254D, 0x24E8, 0x2483, 0x25E0, 0x273D, 0x289A, 0x29F7, 
    0x2B54, 0x2AC1, 0x2A2E, 0x299B, 0x2908, 0x2875, 0xFC13, 0xFDDE, 0xFFA9, 
    0x0174, 0x033F, 0x050A, 0x06D5, 0x089F, 0x0A6A, 0x0C35, 0x0E00, 0x0A9A, 
    0x0734, 0x03CE, 0x0068, 0xFD01, 0xFCD1, 0xFCA2, 0xFC72, 0xFC43, 0xFC13, 
    0xFDDE, 0xFFA9, 0x0174, 0x033F, 0x050A, 0x06D5, 0x089F, 0x0A6A, 0x0C35, 
    0x0E00, 0x0A9A, 0x0734, 0x03CE, 0x0068, 0xFD01, 0xFCD1, 0xFCA2, 0xFC72, 
    0xFC43, 0xFC13, 0xE570, 0xE744, 0xE918, 0xEAEC, 0xECC0, 0xEE94, 0xF068, 
    0xF23C, 0xF410, 0xF5E4, 0xF7B8, 0xF45E, 0xF104, 0xEDAA, 0xEA50, 0xE6F7, 
    0xE6A8, 0xE65A, 0xE60C, 0xE5BE, 0xE570, 0xE744, 0xE918, 0xEAEC, 0xECC0, 
    0xEE94, 0xF068, 0xF23C, 0xF410, 0xF5E4, 0xF7B8, 0xF45E, 0xF104, 0xEDAA, 
    0xEA50, 0xE6F7, 0xE6A8, 0xE65A, 0xE60C, 0xE5BE, 0xE570, 0xFFFF, 0xFFFF, 
    0xC734, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
    0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
    0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
    0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
    0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
    0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
    0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
    0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
    0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
    0x0000, 0xED8B, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
    0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
    0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
    0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
    0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
    0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
    0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
    0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
    0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
    0x0000, 0x0000, 0xFFFF, 0xBF5E, 0xF4ED, 0xF8D3, 0xFCB9, 0x00A0, 0x0486, 
    0x086C, 0x0889, 0x08A7, 0x08C4, 0x08E1, 0x08FF, 0x085A, 0x07B5, 0x0710, 
    0x066C, 0x05C7, 0x0525, 0x0484, 0x03E2, 0x0340, 0x029F, 0xFD8B, 0xF879, 
    0xF366, 0xEE54, 0xE941, 0xE8DE, 0xE87A, 0xE816, 0xE7B3, 0xE74F, 0xE8CE, 
    0xEA4C, 0xEBCB, 0xED49, 0xEEC8, 0xF003, 0xF13D, 0xF278, 0xF3B3, 0xF4ED, 
    0xFB3F, 0xF9DA, 0xF876, 0xF711, 0xF5AD, 0xF449, 0xF101, 0xEDB9, 0xEA71, 
    0xE729, 0xE3E1, 0xE5BD, 0xE799, 0xE976, 0xEB52, 0xED2F, 0xF3B5, 0xFA3B, 
    0x00C3, 0x0749, 0x0DD0, 0x0952, 0x04D5, 0x0058, 0xFBDA, 0xF75D, 0xF498, 
    0xF1D3, 0xEF0E, 0xEC49, 0xE985, 0xED7B, 0xF171, 0xF567, 0xF95E, 0xFD54, 
    0xFCE9, 0xFC7F, 0xFC14, 0xFBA9, 0xFB3F, 0xCB45, 0xCCBA, 0xCE30, 0xCFA5, 
    0xD11B, 0xD290, 0xD816, 0xDD9C, 0xE322, 0xE8A8, 0xEE2E, 0xE7B6, 0xE13F, 
    0xDAC7, 0xD450, 0xCDD9, 0xC3EE, 0xBA03, 0xB018, 0xA62D, 0x9C42, 0x9D18, 
    0x9DEE, 0x9EC4, 0x9F99, 0xA06F, 0x9C9B, 0x98C6, 0x94F2, 0x911D, 0x8D49, 
    0x97AD, 0xA211, 0xAC75, 0xB6D9, 0xC13D, 0xC33E, 0xC540, 0xC742, 0xC943, 
    0xCB45, 0xFFF7, 0xFFF7, 0xFFF7, 0xFFF7, 0xFFF7, 0xFFF7, 0xFFF2, 0xFFEE, 
    0xFFEA, 0xFFE6, 0xFFE1, 0xFF89, 0xFF32, 0xFEDA, 0xFE82, 0xFE2A, 0xFE87, 
    0xFEE4, 0xFF41, 0xFF9E, 0xFFFB, 0xFFF9, 0xFFF7, 0xFFF5, 0xFFF3, 0xFFF1, 
    0xFFF6, 0xFFFA, 0xFFFF, 0x0004, 0x0009, 0xFF5E, 0xFEB5, 0xFE0B, 0xFD62, 
    0xFCB8, 0xFD5E, 0xFE04, 0xFEAB, 0xFF51, 0xFFF7, 0x0009, 0x0009, 0x0009, 
    0x0009, 0x0009, 0x0009, 0x0012, 0x001B, 0x0024, 0x002D, 0x0035, 0xFEF9, 
    0xFDBE, 0xFC83, 0xFB47, 0xFA0C, 0xFB5B, 0xFCA9, 0xFDF7, 0xFF46, 0x0095, 
    0x0093, 0x0090, 0x008E, 0x008C, 0x0089, 0x006C, 0x004F, 0x0032, 0x0015, 
    0xFFF7, 0x01DA, 0x03BC, 0x059E, 0x0780, 0x0962, 0x0784, 0x05A5, 0x03C6, 
    0x01E8, 0x0009, 0x0A05, 0x0A05, 0x0A05, 0x0A05, 0x0A05, 0x0A05, 0x0DC2, 
    0x117F, 0x153B, 0x18F8, 0x1CB5, 0x208D, 0x2466, 0x283F, 0x2C17, 0x2FF0, 
    0x33DD, 0x37CA, 0x3BB7, 0x3FA4, 0x4391, 0x426A, 0x4144, 0x401E, 0x3EF7, 
    0x3DD1, 0x31A3, 0x2575, 0x1947, 0x0D19, 0x00EA, 0x0083, 0x001B, 0xFFB3, 
    0xFF4B, 0xFEE4, 0x011E, 0x0358, 0x0592, 0x07CC, 0x0A05, 0x00A9, 0x00AC, 
    0x00AF, 0x00B1, 0x00B4, 0x00B6, 0x00B9, 0x00BC, 0x00BF, 0x00C3, 0x00C6, 
    0x0145, 0x01C5, 0x0245, 0x02C4, 0x0344, 0x03EF, 0x049A, 0x0545, 0x0304, 
    0x00C3, 0x00C3, 0x00C3, 0x00C3, 0x00C3, 0x00C3, 0x00BD, 0x00B8, 0x00B2, 
    0x00AC, 0x00A6, 0x001C, 0xFF91, 0xFF08, 0xFE7E, 0xFDF4, 0xFE7F, 0xFF09, 
    0xFF94, 0x001F, 0x00A9, 0xFF16, 0xFF19, 0xFF1C, 0xFF1F, 0xFF21, 0xFF24, 
    0xFF29, 0xFF2E, 0xFF33, 0xFF38, 0xFF3E, 0xFE99, 0xFDF5, 0xFD51, 0xFCAD, 
    0xFC09, 0xF9A3, 0xF73D, 0xF4D8, 0xFA08, 0xFF39, 0xFF39, 0xFF39, 0xFF39, 
    0xFF39, 0xFF39, 0xFF31, 0xFF2A, 0xFF22, 0xFF1B, 0xFF13, 0xFF5F, 0xFFAB, 
    0xFFF7, 0x0043, 0x008F, 0x0044, 0xFFF8, 0xFFAD, 0xFF62, 0xFF16, 0xC2CB, 
    0xC15D, 0xBFF0, 0xBE82, 0xBD15, 0xBBA7, 0xB968, 0xB729, 0xB4EA, 0xB2AB, 
    0xB06C, 0xBAEB, 0xC56A, 0xCFE9, 0xDA67, 0xE4E6, 0xE769, 0xE9EB, 0xEC6E, 
    0xCF62, 0xB257, 0xB257, 0xB257, 0xB257, 0xB257, 0xB257, 0xB602, 0xB9AC, 
    0xBD57, 0xC101, 0xC4AC, 0xC707, 0xC963, 0xCBBF, 0xCE1A, 0xD076, 0xCDBA, 
    0xCAFE, 0xC843, 0xC587, 0xC2CB, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
    0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
    0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
    0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
    0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
    0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
    0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
    0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
    0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
    0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xBF5E, 0xFF73, 0x016C, 0x0364, 
    0x055B, 0x0753, 0x094B, 0x08B1, 0x0818, 0x077E, 0x06E5, 0x064C, 0x0877, 
    0x0AA1, 0x0CCC, 0x0EF7, 0x1122, 0x101C, 0x0F16, 0x0E0F, 0x0D09, 0x0C03, 
    0x0887, 0x050C, 0x0190, 0xFE14, 0xFA99, 0xFCA0, 0xFEA8, 0x00B1, 0x02B9, 
    0x04C0, 0x0231, 0xFFA0, 0xFD11, 0xFA82, 0xF7F2, 0xF973, 0xFAF3, 0xFC73, 
    0xFDF3, 0xFF73, 0xF2DD, 0xF761, 0xFBE6, 0x006B, 0x04F0, 0x0974, 0x0D2B, 
    0x10E1, 0x1498, 0x184E, 0x1C05, 0x1724, 0x1243, 0x0D62, 0x0881, 0x03A0, 
    0x038B, 0x0376, 0x0361, 0x034C, 0x0337, 0x0793, 0x0BEF, 0x104B, 0x14A7, 
    0x1903, 0x1A58, 0x1BAC, 0x1D00, 0x1E54, 0x1FA8, 0x1D0D, 0x1A72, 0x17D7, 
    0x153C, 0x12A1, 0x0C47, 0x05EC, 0xFF91, 0xF937, 0xF2DD, 0x9A46, 0x977B, 
    0x94B0, 0x91E5, 0x8F1A, 0x8C4F, 0x8B2F, 0x8A10, 0x88F0, 0x87D0, 0x86B1, 
    0x8EC7, 0x96DE, 0x9EF5, 0xA70C, 0xAF22, 0xB461, 0xB99F, 0xBEDD, 0xC41B, 
    0xC95A, 0xCCBA, 0xD01B, 0xD37C, 0xD6DC, 0xDA3D, 0xDE8F, 0xE2E1, 0xE734, 
    0xEB86, 0xEFD8, 0xECB7, 0xE996, 0xE675, 0xE354, 0xE033, 0xD237, 0xC43B, 
    0xB63F, 0xA842, 0x9A46, 0xFF3C, 0xFF53, 0xFF6B, 0xFF82, 0xFF99, 0xFFB0, 
    0xFFC3, 0xFFD6, 0xFFEA, 0xFFFD, 0x0012, 0x0015, 0x0018, 0x001B, 0x001E, 
    0x0021, 0x0018, 0x000E, 0x0005, 0xFFFA, 0xFFF0, 0xFFF0, 0xFFF0, 0xFFF0, 
    0xFFF0, 0xFFF0, 0xFFF7, 0xFFFE, 0x0005, 0x000C, 0x0013, 0xFFFE, 0xFFEB, 
    0xFFD7, 0xFFC3, 0xFFB0, 0xFF99, 0xFF82, 0xFF6B, 0xFF54, 0xFF3C, 0xFE2B, 
    0xFE38, 0xFE46, 0xFE53, 0xFE60, 0xFE6E, 0xFEB5, 0xFEFD, 0xFF44, 0xFF8C, 
    0xFFD3, 0xFFB9, 0xFFA0, 0xFF86, 0xFF6C, 0xFF52, 0xFF7A, 0xFFA2, 0xFFCA, 
    0xFFF2, 0x001B, 0x001B, 0x001B, 0x001B, 0x001B, 0x001B, 0xFFE3, 0xFFAC, 
    0xFF74, 0xFF3D, 0xFF06, 0xFEE8, 0xFEC9, 0xFEAB, 0xFE8C, 0xFE6E, 0xFE61, 
    0xFE53, 0xFE46, 0xFE38, 0xFE2B, 0x4B45, 0x480A, 0x44CF, 0x4194, 0x3E59, 
    0x3B1E, 0x31AF, 0x2841, 0x1ED2, 0x1563, 0x0BF5, 0x0F18, 0x123C, 0x155F, 
    0x1883, 0x1BA6, 0x16A2, 0x119D, 0x0C99, 0x0795, 0x0290, 0x0290, 0x0290, 
    0x0290, 0x0290, 0x0290, 0x0974, 0x1058, 0x173C, 0x1E1F, 0x2503, 0x296E, 
    0x2DD8, 0x3242, 0x36AC, 0x3B17, 0x3E53, 0x4190, 0x44CC, 0x4809, 0x4B45, 
    0xFF94, 0xFFA9, 0xFFBD, 0xFFD1, 0xFFE5, 0xFFFA, 0xFFFA, 0xFFFA, 0xFFFA, 
    0xFFFA, 0xFFFA, 0xFFEC, 0xFFDF, 0xFFD1, 0xFFC4, 0xFFB6, 0xFFC0, 0xFFCA, 
    0xFFD3, 0xFFDD, 0xFFE7, 0xFFD3, 0xFFBF, 0xFFAB, 0xFF97, 0xFF83, 0xFF81, 
    0xFF7F, 0xFF7C, 0xFF7A, 0xFF78, 0xFFAD, 0xFFE2, 0x0017, 0x004C, 0x0081, 
    0x00D0, 0x011F, 0x016E, 0x0082, 0xFF94, 0x0223, 0x022D, 0x0237, 0x0240, 
    0x024A, 0x0253, 0x0253, 0x0253, 0x0253, 0x0253, 0x0253, 0x024E, 0x0249, 
    0x0243, 0x023E, 0x0238, 0x023C, 0x0241, 0x0245, 0x0249, 0x024D, 0x0242, 
    0x0237, 0x022C, 0x0221, 0x0216, 0x0214, 0x0213, 0x0211, 0x020F, 0x020D, 
    0x021E, 0x022E, 0x023E, 0x024E, 0x025E, 0x0492, 0x06C5, 0x08F9, 0x058E, 
    0x0223, 0xB992, 0xBC48, 0xBEFE, 0xC1B4, 0xC46A, 0xC721, 0xC721, 0xC721, 
    0xC721, 0xC721, 0xC721, 0xC562, 0xC3A2, 0xC1E3, 0xC024, 0xBE65, 0xBFAA, 
    0xC0EF, 0xC234, 0xC37A, 0xC4BF, 0xC1FA, 0xBF35, 0xBC6F, 0xB9AA, 0xB6E5, 
    0xB693, 0xB641, 0xB5EF, 0xB59D, 0xB54B, 0xBC1F, 0xC2F4, 0xC9C8, 0xD09C, 
    0xD771, 0xD990, 0xDBB0, 0xDDD0, 0xCBB1, 0xB992,
    },
    {
    0x0001, 0x0000, 0x0029, 0x0001, 0x0001, 0x002A, 0x0001, 0x002B, 0x0001, 
    0x002C, 0x0001, 0x002D, 0x0029, 0x002E, 0x0029, 0x0057, 0x0029, 0x0080, 
    0x0029, 0x00A9, 0x0029, 0x00D2, 0x0029, 0x00FB, 0x0029, 0x0124, 0x0029, 
    0x014D, 0x0029, 0x0176, 0x0001, 0x019F, 0x0001, 0x01A0, 0x0001, 0x01A1, 
    0x0029, 0x01A2, 0x0029, 0x01CB, 0x0029, 0x01F4, 0x0001, 0x021D, 0x0001, 
    0x021E, 0x0001, 0x021F, 0x0001, 0x0220, 0x0001, 0x0221, 0x0001, 0x0222, 
    0x0001, 0x0223, 0x0001, 0x0224, 0x0001, 0x0225, 0x0029, 0x0226, 0x0029, 
    0x024F, 0x0029, 0x0278, 0x0001, 0x02A1, 0x0001, 0x02A2, 0x0001, 0x02A3, 
    0x0028, 0x02A4, 0x0029, 0x02CC, 0x0001, 0x02F5, 0x0029, 0x02F6, 0x0029, 
    0x031F, 0x0001, 0x0348, 0x0029, 0x0349, 0x0029, 0x0372, 0x0029, 0x039B, 
    0x0029, 0x03C4, 0x0029, 0x03ED, 0x0029, 0x0416, 0x0029, 0x043F, 0x0029, 
    0x0468, 0x0029, 0x0491, 0x0029, 0x04BA, 0x0029, 0x04E3, 0x0001, 0x050C, 
    0x0029, 0x050D, 0x0029, 0x0536, 0x0029, 0x055F, 0x0029, 0x0588, 0x0029, 
    0x05B1, 0x0029, 0x05DA, 0x0029, 0x0603, 0x0029, 0x062C, 0x0029, 0x0655, 
})

